#lang racket

(require vigracket)

;; Main program
;; -----------------------------------------------------------------------------
(define image_dir (current-directory))

(define resized_img (load-image (build-path image_dir "IMG_0717rot_small.JPG")))
(define work_img (image->green resized_img))

(define dict_work_img  (load-image (build-path image_dir "dict.png")))

;;Finde alle Einsen (Vertikal/Spielfeld)
(define work_template (subimage dict_work_img 4 4 27 27))

;;Finde alle Neunen (Vertikal/Spielfeld) -> Achtung: Findet auch 6en/gedrehte Neunen...
;(define work_template (subimage dict_work_img 3 248 26 271))

(show-image work_template "Template image")

;; Schnelle, normierte Kreuzkorrelation:
(define res_ncc (fastnormalizedcrosscorrelation work_img work_template))

;;Nur Korrelationskoeffizienten >T betrachten
(define res_ncc_thresh (image-map (lambda (v) (if (<= v 0.9)  0.0 v)) res_ncc))

;;Lokale Maxima finden
(define res_local_max (localmaxima res_ncc_thresh))

;;Zum Zeichen: Maxima "dicker" machen und auf den Rot-Kanal max-en
(define highlight_img (dilateimage (image-map (curry * 255.0) res_local_max) 10))
(show-image (append (image-map max highlight_img work_img) work_img work_img) "Search result image")