#lang racket

(require vigracket)

;; Main program
;; -----------------------------------------------------------------------------
(define image_dir (current-directory))

(define resized_img (load-image (build-path image_dir "IMG_0717rot_small.JPG")))
(define work_img (image->green resized_img))

(define dict_work_img  (load-image (build-path image_dir "dict.png")))

;;Oben Mitte: Rote 1
;(define work_template (subimage work_img 264 164 295 195))

;;Unten rechts, Joker (schwarz)
;(define work_template (subimage work_img 401 511 426 536))

;;Unten links:
(define work_template (subimage work_img 133 609 156 632))

(show-image work_template "Template image")

;; Schnelle, normierte Kreuzkorrelation:
(define res_ncc (fastnormalizedcrosscorrelation dict_work_img work_template))

;;Nur Korrelationskoeffizienten >Threshold betrachten
(define res_ncc_thresh (image-map (lambda (v) (if (<= v 0.9)  0.0 v)) res_ncc))

;;Lokale Maxima finden
(define res_local_max (localmaxima res_ncc_thresh))

;;Zum Zeichen: Maxima "dicker" machen und auf den Rot-Kanal max-en
(define highlight_img (dilateimage (image-map (curry * 255.0) res_local_max) 10))
(show-image (append (image-map max highlight_img dict_work_img) dict_work_img dict_work_img) "Search result image")