#lang racket

(require vigracket)

;; Main program
;; -----------------------------------------------------------------------------
(define image_dir (current-directory))

(define resized_img (load-image (build-path image_dir "IMG_1050small.JPG")))
(define work_img (image->green resized_img))

;;Bauer
(define template (subimage work_img 520 324 543 359))

;;Großes Ding
;(define template (subimage work_img 583 251 616 298))

;;Turm?
;(define template (subimage work_img 517 186 544 229))

;;Auto rotates template img, if nessary:
;;Always select odd-sized semplates for the enemy (plays from top to bottom)
;;set to #f to get template for other (my) player.
(define search_enemy #f)

(define work_template (if search_enemy
                          template
                          (rotateimage template 180.0)))

(show-image work_template "Template image")

;; Schnelle, normierte Kreuzkorrelation:
(define res_ncc (fastnormalizedcrosscorrelation work_img work_template))

;;Nur Korrelationskoeffizienten > 0.7 betrachten
(define res_ncc_thresh (image-map (lambda (v) (if (<= v 0.7)  0.0 v)) res_ncc))

;;Lokale Maxima finden
(define res_local_max (localmaxima res_ncc_thresh))

;;Zum Zeichen: Maxima "dicker" machen und auf den Rot-Kanal max-en
(define highlight_img (dilateimage (image-map (curry * 255.0) res_local_max) 10))
(show-image (append (image-map max highlight_img work_img) work_img work_img) "Search result image")